Bug 116365 - Crash in: BitmapReadAccess::SetPixelForN24BitTcRgb(unsigned char *,long,BitmapColor const &,ColorMask const &) if OpenGL is enabled
Summary: Crash in: BitmapReadAccess::SetPixelForN24BitTcRgb(unsigned char *,long,Bitma...
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Writer (show other bugs)
Version:
(earliest affected)
5.4.3.2 release
Hardware: All All
: highest critical
Assignee: Miklos Vajna
URL:
Whiteboard: target:6.1.0 target:6.0.5
Keywords: wantBacktrace
Depends on:
Blocks: OpenGL
  Show dependency treegraph
 
Reported: 2018-03-12 15:42 UTC by Thomas Lendo
Modified: 2018-09-16 18:04 UTC (History)
7 users (show)

See Also:
Crash report or crash signature: ["BitmapReadAccess::SetPixelForN24BitTcRgb(unsigned char *,long,BitmapColor const &,ColorMask const &)"]


Attachments
File where the crash happens, password: BdT8GfhSLBpuxTgZ (157.28 KB, application/x-zip-compressed)
2018-03-12 15:42 UTC, Thomas Lendo
Details
Screenshot of testfile: on the left without GL, on the right with activated GL (9.39 KB, image/png)
2018-05-04 09:48 UTC, Thomas Lendo
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Thomas Lendo 2018-03-12 15:42:13 UTC
Created attachment 140582 [details]
File where the crash happens, password: BdT8GfhSLBpuxTgZ

This bug was filed from the crash reporting server and is br-e268e995-ea7b-46b3-920b-96d9f93db30e.

Version: 6.0.0.3 (x64)
Build-ID: 64a0f66915f38c6217de274f0aa8e15618924765
CPU-Threads: 8; BS: Windows 10.0; UI-Render: GL; 
Gebietsschema: de-AT (de_AT); Calc: group
=========================================

This bug was filed from the crash reporting server and is br-0c8c7e96-f691-42a9-ab41-ef02a8fdd054.

Version: 5.4.3.2 (x64)
Build-ID: 92a7159f7e4af62137622921e809f8546db437e5
CPU-Threads: 8; Betriebssystem:Windows 6.19; UI-Render: GL; 
Gebietsschema: de-AT (de_AT); Calc: group
=========================================

LibO 6.1 crashes but no crash report is generated.

Version: 6.1.0.0.alpha0+ (x64)
Build ID: cab04bc39b5164ea74216cd849c3af5f5b298f79
CPU threads: 8; OS: Windows 10.0; UI render: GL; 
TinderBox: Win-x86_64@42, Branch:master, Time: 2018-03-12_00:50:50
Locale: de-AT (de_AT); Calc: CL

LibO 3.3 can open it without crash.

LibreOffice 3.3.0 
OOO330m19 (Build:6)
tag libreoffice-3.3.0.4


The attached file was created with LibO 5.1.4.2 (Windows X86_64), f99d75f39f1c57ebdd7ffc5f42867c12031db97a.
Comment 1 Dieter Praas 2018-03-12 16:05:44 UTC
I could open the file with no crash in

Version: 5.4.6.1 (x64)
Build-ID: 7d6c666f03cf1f0a0c2c51a17c0f67a8d5a8012b
CPU-Threads: 4; BS: Windows 6.19; UI-Render: Standard; 
Gebietsschema: de-DE (de_DE); Calc: group


I saved the document and opened it with

Version: 6.1.0.0.alpha0+ (x64)
Build ID: d64ce643275e0b2b0dea9e532fc261391dc8793c
CPU threads: 4; OS: Windows 10.0; UI render: GL; 
TinderBox: Win-x86_64@42, Branch:master, Time: 2018-03-01_03:24:30
Locale: de-DE (de_DE); Calc: CL

=> Crash

I disabled OpenGL => No crash with 6.1.0.0.alpha0+
Comment 2 Julien Nabet 2018-03-12 20:50:38 UTC
Again an OpenGL related crash. Hope it really helps in perf when it works because there are quite a lot of this kind.
Comment 3 Michael Meeks 2018-03-13 11:19:01 UTC
Thank for the report - quikee - can you take a look ?
Comment 4 Telesto 2018-03-27 16:46:15 UTC
Repro with
Version: 6.1.0.0.alpha0+
Build ID: 42b80f4ed300b08074ed3a6dd48679afd5af760a
CPU threads: 4; OS: Windows 6.3; UI render: GL; 
Locale: nl-NL (nl_NL); Calc: CL

but not with
Version: 6.1.0.0.alpha0+
Build ID: 546ed01e62c9a36a675c7390371aaec7f1647a33
CPU threads: 4; OS: Windows 6.3; UI render: GL; 
TinderBox: Win-x86@42, Branch:master, Time: 2018-03-26_15:39:48
Locale: nl-NL (nl_NL); Calc: CL
Comment 5 Miklos Vajna 2018-04-26 11:56:18 UTC
I don't get a crash, but instead I get a black image at the bottom of the page when GL is enabled. The image shows fine when GL is off. I plan to take a look at that.
Comment 6 Commit Notification 2018-04-27 14:55:05 UTC
Miklos Vajna committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=a3cbd06872b2f9ee9253e5879f590ff1b9eaf365

tdf#116365 vcl opengl: respect max texture size when creating textures

It will be available in 6.1.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 7 Commit Notification 2018-05-03 20:05:19 UTC
Miklos Vajna committed a patch related to this issue.
It has been pushed to "libreoffice-6-0":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=443b2e6359955b107ba951636b2491b9444d0fee&h=libreoffice-6-0

tdf#116365 vcl opengl: respect max texture size when creating textures

It will be available in 6.0.5.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 8 Thomas Lendo 2018-05-04 09:48:11 UTC
Created attachment 141888 [details]
Screenshot of testfile: on the left without GL, on the right with activated GL

Miklos, thanks very much for your patch!

A follow-up question:
The image isn't causing a crash or a black object anymore, but with activated GL the picture is stretched in the length (but the total length of the image, as shown in the document, is the same as before). The attached screenshot shows the original and correct displayed image without GL on the left, the right side shows the stretched image with activated GL.


Tested with version 6.1.0.0.alpha1+ (x64)
Build ID: 409b7636f0e519f9ab14bac7884789b2323557c7
CPU threads: 8; OS: Windows 10.0; UI render: GL; 
TinderBox: Win-x86_64@42, Branch:master, Time: 2018-05-03_23:47:22
Locale: de-AT (de_AT); Calc: CL